---
title: Getting Browser Microphone Permission
slug: >-
  Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/get_microphone_permission
---
{{WebRTCSidebar}}

<div>{{PreviousMenuNext("Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers", "Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/show_hide_html")}}</div>

<p id="cdf0">After you’ve created the peer, you’ll want to get the browser’s permission to access the microphone. We’ll be using the <code>getUserMedia</code> function on the <code>navigator.MediaDevices</code> object, which is part of the <a href="/en-US/docs/Web/API/MediaDevices/getUserMedia" rel="noopener nofollow">Media Devices Web interface</a>. The <code>getUserMedia</code> endpoint takes a <code>constraints</code> object which specifies which permissions are needed. <code>getUserMedia</code> is a promise which when successfully resolved returns a <code>MediaStream</code> object. In this case this is going to be the audio from our stream. If the promise isn’t successfully resolved, you’ll want to catch and display the error.</p>

<pre class="brush: js notranslate">function getLocalStream() {
    <strong><em>navigator</em></strong>.mediaDevices.getUserMedia({video: false, audio: true}).then( stream =&gt; {
        <strong><em>window</em></strong>.localStream = stream; // A
        <strong><em>window</em></strong>.localAudio.srcObject = stream; // B
        <strong><em>window</em></strong>.localAudio.autoplay = true; // C
    }).catch( err =&gt; {
        <strong><em>console</em></strong>.log("u got an error:" + err)
    });
}</pre>

<p id="06e6">A. <code>window.localStream = stream</code> : here we’re attaching the <code>MediaStream</code> object (which we have assigned to <code>stream</code> on the previous line) to the window as the <code>localStream</code> .</p>

<p id="d24d">B. <code>window.localAudio.srcObject = stream</code>: in our HTML, we have an <a href="/en-US/docs/Web/HTML/Element/audio" rel="noopener nofollow">audio element</a> with the ID <code>localAudio</code>, we’re setting that element’s src attribute to be the <code>MediaStream </code>returned by the promise.</p>

<p id="f23a">C. <code>window.localAudio.autoplay = true</code>: we’re setting the autoplay attribute for the audio element to auto play.</p>

<div class="notecard warning">
<p>If you’ve done some sleuthing online, you may have come across <code>navigator.getUserMedia</code> and assumed you can use that instead of <code>navigator.MediaDevices.getUserMedia</code>. You’d be wrong. The former is a <a href="/en-US/docs/Web/API/Navigator/getUserMedia" rel="noopener nofollow">deprecated method</a> which requires callbacks as well as constraints as arguments. The latter uses a promise so you don’t need to use callbacks.</p>
</div>

<p id="3a7f">When you call your <code>getLocalStream</code> function and refresh your browser, you should see the following permission pop up:</p>

<p><img alt='A browser permission dialogue box which says "http://localhost:8000 wants to use your microphone" with two options: "block" and "allow"' src="https://miro.medium.com/max/1400/1*oIEIZmFmLlNYGBsdu4F1iQ.png" style="height: 674px; width: 980px;"></p>

<p id="6d6e">Use headphones before you allow so that when you unmute yourself later, you don’t get any feedback. If you don’t see this, open the inspector and see if you have any errors. Make sure your javascript file is correctly linked to your <code>index.html</code> too.</p>

<p id="ed16">This what it should all look like together:</p>

<pre class="brush: js notranslate">/* global Peer */

/**
 * Gets the local audio stream of the current caller
 * @param callbacks - an object to set the success/error behaviour
 * @returns {void}
 */

function getLocalStream() {
    navigator.mediaDevices.getUserMedia({video: false, audio: true}).then( stream =&gt; {
        window.localStream = stream;
        window.localAudio.srcObject = stream;
        window.localAudio.autoplay = true;
    }).catch( err =&gt; {
        console.log("u got an error:" + err)
    });
}

getLocalStream();

</pre>

<div>{{PreviousMenuNext("Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers", "Web/API/WebRTC_API/build_a_phone_with_peerjs/connect_peers/show_hide_html")}}</div>
